Index: /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Willcom.php
===================================================================
--- /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Willcom.php	(revision 17140)
+++ /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Willcom.php	(revision 18188)
@@ -5,15 +5,33 @@
  * PHP versions 4 and 5
  *
- * LICENSE: This source file is subject to version 3.0 of the PHP license
- * that is available through the world-wide-web at the following URI:
- * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
- * the PHP License and are unable to obtain it through the web, please
- * send a note to license@php.net so we can mail you a copy immediately.
+ * Copyright (c) 2003-2009 KUBO Atsuhiro <kubo@iteman.jp>,
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
  *
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
  * @version    CVS: $Id$
  * @link       http://www.willcom-inc.com/ja/service/contents_service/club_air_edge/for_phone/homepage/index.html
@@ -29,7 +47,6 @@
  * AirH"PHONE implementation
  *
- * Net_UserAgent_Mobile_Willcom is a subclass of
- * {@link Net_UserAgent_Mobile_Common}, which implements Willcom's user
- * agents.
+ * Net_UserAgent_Mobile_Willcom is a subclass of {@link Net_UserAgent_Mobile_Common},
+ * which implements Willcom's user agents.
  *
  * SYNOPSIS:
@@ -51,10 +68,9 @@
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
- * @version    Release: 0.31.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
+ * @version    Release: 1.0.0
  * @link       http://www.willcom-inc.com/ja/service/contents_service/club_air_edge/for_phone/homepage/index.html
- * @see        Net_UserAgent_Mobile_Common
  * @since      Class available since Release 0.5
  */
@@ -154,7 +170,5 @@
      * create a new {@link Net_UserAgent_Mobile_Display} class instance
      *
-     * @return object a newly created {@link Net_UserAgent_Mobile_Display}
-     *     object
-     * @see Net_UserAgent_Mobile_Display
+     * @return Net_UserAgent_Mobile_Display
      */
     function makeDisplay()
Index: /branches/comu-ver2/data/module/Net/UserAgent/Mobile/SoftBank.php
===================================================================
--- /branches/comu-ver2/data/module/Net/UserAgent/Mobile/SoftBank.php	(revision 17140)
+++ /branches/comu-ver2/data/module/Net/UserAgent/Mobile/SoftBank.php	(revision 18188)
@@ -5,16 +5,35 @@
  * PHP versions 4 and 5
  *
- * LICENSE: This source file is subject to version 3.0 of the PHP license
- * that is available through the world-wide-web at the following URI:
- * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
- * the PHP License and are unable to obtain it through the web, please
- * send a note to license@php.net so we can mail you a copy immediately.
+ * Copyright (c) 2003-2009 KUBO Atsuhiro <kubo@iteman.jp>,
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
  *
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
  * @version    CVS: $Id$
+ * @link       http://creation.mb.softbank.jp/
  * @since      File available since Release 0.20.0
  */
@@ -22,4 +41,5 @@
 require_once dirname(__FILE__) . '/Common.php';
 require_once dirname(__FILE__) . '/Display.php';
+require_once dirname(__FILE__) . '/../Mobile.php';
 
 // {{{ Net_UserAgent_Mobile_SoftBank
@@ -28,6 +48,6 @@
  * SoftBank implementation
  *
- * Net_UserAgent_Mobile_SoftBank is a subclass of
- * {@link Net_UserAgent_Mobile_Common}, which implements SoftBank user agents.
+ * Net_UserAgent_Mobile_SoftBank is a subclass of {@link Net_UserAgent_Mobile_Common},
+ * which implements SoftBank user agents.
  *
  * SYNOPSIS:
@@ -59,11 +79,9 @@
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
- * @version    Release: 0.31.0
- * @link       http://developers.vodafone.jp/dp/tool_dl/web/useragent.php
- * @link       http://developers.vodafone.jp/dp/tool_dl/web/position.php
- * @see        Net_UserAgent_Mobile_Common
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
+ * @version    Release: 1.0.0
+ * @link       http://creation.mb.softbank.jp/
  * @since      Class available since Release 0.20.0
  */
@@ -93,5 +111,5 @@
      * @var string
      */
-    var $_serialNumber = null;
+    var $_serialNumber;
 
     /**
@@ -105,5 +123,5 @@
      * @var string
      */
-    var $_vendorVersion = null;
+    var $_vendorVersion;
 
     /**
@@ -164,5 +182,5 @@
      *
      * @param string $userAgent User-Agent string
-     * @return mixed void, or a PEAR error object on error
+     * @throws Net_UserAgent_Mobile_Error
      */
     function parse($userAgent)
@@ -208,12 +226,9 @@
      * create a new {@link Net_UserAgent_Mobile_Display} class instance
      *
-     * @return object a newly created {@link Net_UserAgent_Mobile_Display}
-     *     object
-     * @see Net_UserAgent_Mobile_Display
+     * @return Net_UserAgent_Mobile_Display
      */
     function makeDisplay() 
     {
-        @list($width, $height) =
-            explode('*', $this->getHeader('X-JPHONE-DISPLAY'));
+        @list($width, $height) = explode('*', $this->getHeader('X-JPHONE-DISPLAY'));
         $color = false;
         $depth = 0;
@@ -223,6 +238,6 @@
             $depth = $matches[2];
         }
-        return new Net_UserAgent_Mobile_Display(array(
-                                                      'width'  => $width,
+
+        return new Net_UserAgent_Mobile_Display(array('width'  => $width,
                                                       'height' => $height,
                                                       'depth'  => $depth,
@@ -248,6 +263,6 @@
 
     /**
-     * return terminal unique serial number. returns null if user forbids to
-     * send his/her serial number.
+     * return terminal unique serial number. returns null if user forbids to send
+     * his/her serial number.
      *
      * @return string
@@ -419,4 +434,20 @@
     }
 
+    // }}}
+    // {{{ getUID()
+
+    /**
+     * Gets the UID of a subscriber.
+     *
+     * @return string
+     * @since Method available since Release 1.0.0RC1
+     */
+    function getUID()
+    {
+        if (array_key_exists('HTTP_X_JPHONE_UID', $_SERVER)) {
+            return $_SERVER['HTTP_X_JPHONE_UID'];
+        }
+    }
+
     /**#@-*/
 
@@ -432,9 +463,8 @@
      *
      * @param array $agent parts of the User-Agent string
-     * @return mixed void, or a PEAR error object on error
-     */
-    function _parseVodafone(&$agent)
-    {
-        $count = count($agent);
+     * @throws Net_UserAgent_Mobile_Error
+     */
+    function _parseVodafone($agent)
+    {
         $this->_packetCompliant = true;
 
@@ -448,4 +478,5 @@
                 return $this->noMatch();
             }
+
             $this->_serialNumber = $matches[1];
         }
@@ -458,6 +489,6 @@
         $this->_vendorVersion = $matches[2];
 
-        for ($i = 2; $i < $count; ++$i) {
-            list($key, $value) = explode('/', $agent[$i]);
+        for ($i = 2, $count = count($agent); $i < $count; ++$i) {
+            @list($key, $value) = explode('/', $agent[$i]);
             $this->_javaInfo[$key] = $value;
         }
@@ -471,7 +502,7 @@
      *
      * @param array $agent parts of the User-Agent string
-     * @return mixed void, or a PEAR error object on error
-     */
-    function _parseJphone(&$agent)
+     * @throws Net_UserAgent_Mobile_Error
+     */
+    function _parseJphone($agent)
     {
         $count = count($agent);
@@ -482,17 +513,17 @@
             // J-PHONE/4.0/J-SH51/SNJSHA3029293 SH/0001aa Profile/MIDP-1.0 Configuration/CLDC-1.0 Ext-Profile/JSCL-1.1.0
             $this->_packetCompliant = true;
-            @list($this->name, $this->version, $this->_rawModel,
-                  $serialNumber) = explode('/', $agent[0]);
+            @list($this->name, $this->version, $this->_rawModel, $serialNumber) =
+                explode('/', $agent[0]);
             if ($serialNumber) {
                 if (!preg_match('!^SN(.+)!', $serialNumber, $matches)) {
                     return $this->noMatch();
                 }
+
                 $this->_serialNumber = $matches[1];
             }
 
-            list($this->_vendor, $this->_vendorVersion) =
-                explode('/', $agent[1]);
+            @list($this->_vendor, $this->_vendorVersion) = explode('/', $agent[1]);
             for ($i = 2; $i < $count; ++$i) {
-                list($key, $value) = explode('/', $agent[$i]);
+                @list($key, $value) = explode('/', $agent[$i]);
                 $this->_javaInfo[$key] = $value;
             }
@@ -500,10 +531,11 @@
 
             // J-PHONE/2.0/J-DN02
-            @list($this->name, $this->version, $this->_rawModel,
-                  $serialNumber) = explode('/', $agent[0]);
+            @list($this->name, $this->version, $this->_rawModel, $serialNumber) =
+                explode('/', $agent[0]);
             if ($serialNumber) {
                 if (!preg_match('!^SN(.+)!', $serialNumber, $matches)) {
                     return $this->noMatch();
                 }
+
                 $this->_serialNumber = $matches[1];
             }
@@ -526,18 +558,16 @@
      *
      * @param array $agent parts of the User-Agent string
-     * @return mixed void, or a PEAR error object on error
-     */
-    function _parseMotorola(&$agent)
-    {
-        $count = count($agent);
+     */
+    function _parseMotorola($agent)
+    {
         $this->_packetCompliant = true;
         $this->_vendor = 'MOT';
 
         // MOT-V980/80.2F.2E. MIB/2.2.1 Profile/MIDP-2.0 Configuration/CLDC-1.1
-        list($this->_rawModel, $this->_vendorVersion) = explode('/', $agent[0]);
+        @list($this->_rawModel, $this->_vendorVersion) = explode('/', $agent[0]);
         $this->_model = substr(strrchr($this->_rawModel, '-'), 1);
 
-        for ($i = 2; $i < $count; ++$i) {
-            list($key, $value) = explode('/', $agent[$i]);
+        for ($i = 2, $count = count($agent); $i < $count; ++$i) {
+            @list($key, $value) = explode('/', $agent[$i]);
             $this->_javaInfo[$key] = $value;
         }
Index: /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Common.php
===================================================================
--- /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Common.php	(revision 17140)
+++ /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Common.php	(revision 18188)
@@ -5,20 +5,39 @@
  * PHP versions 4 and 5
  *
- * LICENSE: This source file is subject to version 3.0 of the PHP license
- * that is available through the world-wide-web at the following URI:
- * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
- * the PHP License and are unable to obtain it through the web, please
- * send a note to license@php.net so we can mail you a copy immediately.
+ * Copyright (c) 2003-2009 KUBO Atsuhiro <kubo@iteman.jp>,
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
  *
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
  * @version    CVS: $Id$
  * @since      File available since Release 0.1
  */
 
-require_once dirname(__FILE__) . '/../Mobile.php';
+require_once dirname(__FILE__) . '/Error.php';
+require_once dirname(__FILE__) . '/../../../PEAR.php';
 
 // {{{ Net_UserAgent_Mobile_Common
@@ -32,11 +51,11 @@
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
- * @version    Release: 0.31.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
+ * @version    Release: 1.0.0
  * @since      Class available since Release 0.1
  */
-class Net_UserAgent_Mobile_Common extends PEAR
+class Net_UserAgent_Mobile_Common
 {
 
@@ -72,6 +91,5 @@
 
     /**
-     * {@link Net_UserAgent_Mobile_Error} object for error handling in the
-     *     constructor
+     * {@link Net_UserAgent_Mobile_Error} object for error handling in the constructor
      * @var object
      **/
@@ -117,28 +135,27 @@
     function Net_UserAgent_Mobile_Common($userAgent)
     {
-        parent::PEAR('Net_UserAgent_Mobile_Error');
+        $this->_userAgent = $userAgent;
 
         $result = $this->parse($userAgent);
-        if (Net_UserAgent_Mobile::isError($result)) {
-            $this->isError($result);
+        if (PEAR::isError($result)) {
+            $this->_error = &$result;
         }
-
-        $this->_userAgent = $userAgent;
-    }
-
-    // }}}
-    // {{{ isError
-
-    /**
-     * Returns/set an error when the instance couldn't initialize properly
-     *
-     * @param object {@link Net_UserAgent_Mobile_Error} object when setting
-     *     an error
-     * @return object {@link Net_UserAgent_Mobile_Error} object
-     */
-    function &isError($error = null)
-    {
-        if ($error !== null) {
-            $this->_error = &$error;
+    }
+
+    // }}}
+    // {{{ getError
+
+    /**
+     * Gets a Net_UserAgent_Mobile_Error object.
+     *
+     * @param object {@link Net_UserAgent_Mobile_Error} object when setting an error
+     * @return Net_UserAgent_Mobile_Error
+     * @since Method available since Release 1.0.0RC2
+     */
+    function &getError()
+    {
+        if (is_null($this->_error)) {
+            $return = null;
+            return $return;
         }
 
@@ -147,44 +164,4 @@
 
     // }}}
-    // {{{ raiseError()
-
-    /**
-     * This method is used to communicate an error and invoke error
-     * callbacks etc. Basically a wrapper for PEAR::raiseError without
-     * the message string.
-     *
-     * @param mixed $code integer error code, or a PEAR error object (all
-     *     other parameters are ignored if this parameter is an object
-     * @param int $mode error mode, see PEAR_Error docs
-     * @param mixed $options If error mode is PEAR_ERROR_TRIGGER, this is the
-     *     error level (E_USER_NOTICE etc). If error mode is
-     *     PEAR_ERROR_CALLBACK, this is the callback function, either as a
-     *     function name, or as an array of an object and method name. For
-     *     other error modes this parameter is ignored.
-     * @param string $userinfo Extra debug information. Defaults to the last
-     *     query and native error code.
-     * @return object a PEAR error object
-     * @see PEAR_Error
-     */
-    function &raiseError($code = NET_USERAGENT_MOBILE_ERROR, $mode = null,
-                         $options = null, $userinfo = null
-                         )
-    {
-
-        // The error is yet a Net_UserAgent_Mobile error object
-        if (is_object($code)) {
-            $error = &PEAR::raiseError($code, null, null, null, null, null,
-                                       true
-                                       );
-            return $error;
-        }
-
-        $error = &PEAR::raiseError(null, $code, $mode, $options, $userinfo,
-                                   'Net_UserAgent_Mobile_Error', true
-                                   );
-        return $error;
-    }
-
-    // }}}
     // {{{ getUserAgent()
 
@@ -232,13 +209,12 @@
      * returns {@link Net_UserAgent_Mobile_Disply} object
      *
-     * @return object a {@link Net_UserAgent_Mobile_Display} object, or a
-     *     PEAR error object on error
-     * @see Net_UserAgent_Mobile_Display
+     * @return Net_UserAgent_Mobile_Display
      */
     function getDisplay()
     {
-        if (!is_object($this->_display)) {
+        if (is_null($this->_display)) {
             $this->_display = $this->makeDisplay();
         }
+
         return $this->_display;
     }
@@ -263,12 +239,15 @@
      * generates a warning message for new variants
      *
-     * @return object a PEAR error object
+     * @throws Net_UserAgent_Mobile_Error
      */
     function noMatch()
     {
-        return $this->raiseError(NET_USERAGENT_MOBILE_ERROR_NOMATCH, null,
-                                 null, $this->getUserAgent() .
-                                 ': might be new variants. Please contact the author of Net_UserAgent_Mobile!'
-                                 );
+        return PEAR::raiseError($this->getUserAgent() . ': might be new variants. Please contact the author of Net_UserAgent_Mobile!',
+                                NET_USERAGENT_MOBILE_ERROR_NOMATCH,
+                                null,
+                                null,
+                                null,
+                                'Net_UserAgent_Mobile_Error'
+                                );
     }
 
@@ -291,10 +270,8 @@
      * implemented in subclasses)
      *
+     * @return Net_UserAgent_Mobile_Display
      * @abstract
      */
-    function makeDisplay()
-    {
-        die();
-    }
+    function makeDisplay() {}
 
     // }}}
@@ -500,4 +477,15 @@
         return $this->_rawModel;
     }
+
+    // }}}
+    // {{{ getUID()
+
+    /**
+     * Gets the UID of a subscriber.
+     *
+     * @return string
+     * @since Method available since Release 1.0.0RC1
+     */
+    function getUID() {}
 
     /**#@-*/
Index: /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Error.php
===================================================================
--- /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Error.php	(revision 18188)
+++ /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Error.php	(revision 18188)
@@ -0,0 +1,80 @@
+<?php
+/* vim: set expandtab tabstop=4 shiftwidth=4: */
+
+/**
+ * PHP versions 4 and 5
+ *
+ * Copyright (c) 2009 KUBO Atsuhiro <kubo@iteman.jp>,
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ *
+ * @category   Networking
+ * @package    Net_UserAgent_Mobile
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
+ * @version    CVS: $Id: Error.php,v 1.1 2009/05/26 08:48:16 kuboa Exp $
+ * @since      File available since Release 1.0.0RC3
+ */
+
+require_once dirname(__FILE__) . '/../../../PEAR.php';
+
+// {{{ constants
+
+/**
+ * Constants for error handling.
+ */
+define('NET_USERAGENT_MOBILE_OK',               1);
+define('NET_USERAGENT_MOBILE_ERROR',           -1);
+define('NET_USERAGENT_MOBILE_ERROR_NOMATCH',   -2);
+define('NET_USERAGENT_MOBILE_ERROR_NOT_FOUND', -3);
+
+// }}}
+// {{{ Net_UserAgent_Mobile_Error
+
+/**
+ * Net_UserAgent_Mobile_Error implements a class for reporting user agent error
+ * messages
+ *
+ * @category   Networking
+ * @package    Net_UserAgent_Mobile
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
+ * @version    Release: 1.0.0
+ * @since      Class available since Release 0.1
+ */
+class Net_UserAgent_Mobile_Error extends PEAR_Error {}
+
+// }}}
+
+/*
+ * Local Variables:
+ * mode: php
+ * coding: iso-8859-1
+ * tab-width: 4
+ * c-basic-offset: 4
+ * c-hanging-comment-ender-p: nil
+ * indent-tabs-mode: nil
+ * End:
+ */
